#
# AS namespace
#

# $Id: as_search.rb,v 1.4 2002/10/05 16:17:12 elca Exp $

require "socket"
require "timeout"

require "cache.rb"
require "util.rb"

Ra_host = "198.108.0.18" # whois.ra.net

$whois_cache = Hash.new

#require "multilog"
#ML = MultiLog.new
#ML.open

# from Michael Neumann (neumann@s-direktnet.de)'s whois.rb
def raw_whois (send_string, host)
  s = TCPsocket.open(host, 43)
  s.write(send_string + "\n")
  ret = ""
  while l = s.gets
    ret += l
  end
  s.close
  return ret
end

def as_get(str)
  begin
    tmp = nil
    as  = nil
    net = nil

    timeout(30) {
      tmp = raw_whois(str, Ra_host)
    }
    tmp.split("\n").each {
      |i|
      if /^origin:/ =~ i
	as = i.split[1]
      end
      if /^route:/  =~ i
	net = i.split[1]
      end
    }
    if as != nil && net != nil
      return {"route" => net, "as" => as}
    end

    return nil
  rescue
    return nil
  end
end

def as_search(str)
  #p $whois_cache

  netaddrs = [str] + ip_masklist(str)

  # $B$^$:%-%c%C%7%e$rC5:w(B
  netaddrs.each {
    |i|
    if $whois_cache[i] != nil
      ML.log("cached AS: " + i + "=>" + $whois_cache[i]["as"])
      return $whois_cache[i]["as"]
    end
  }

  # $BF1$8MW5a$,=8Cf$7$?;~$O(B ra.net $B$KLd$$9g$o$;$,=8Cf$7$J$$$h$&$K(B
  # $B%m%C%/$7$F$*$/!#(B
  $whois_cache[str] = {
    "timeout" => Time.now.to_i + 60,   # 1$BJ,(B
    "as"      => "default"
  }


  # ra.net $B$KLd$$9g$o$;!#7k2L$,F@$i$l$?>l9g$O$=$N7k2L$G%-%c%C%7%e$r>e=q$-$9$k!#(B
  tmp = as_get(str)
  if tmp != nil
    $whois_cache.delete(str)

    as  = tmp["as"]
    net = tmp["route"]

    ML.log("add AS cache: " + net + "=>" + as)
    $whois_cache[net] = {
      "timeout" => Time.now.to_i + 10800, # 3$B;~4V(B
      "as"      => as
    }
    return tmp["as"]
  end

  # $B$&$^$/Ld$$9g$o$;$N7k2L$,F@$i$l$J$$>l9g$O%-%c%C%7%e$r$=$N$^$^$K$7$F(B
  # nil $B$rJV$9!#(B
  ML.log("add NULL AS cache: " + str + "=>default")

  return nil
end

# $BDj4|E*$K8E$$FbMF$r:o=|(B
Thread.start do
  loop do
    sleep 15
    # $B%-%c%C%7%e$K;~4V@)8B$r$+$1$k(B
    cache_timeout($whois_cache, "as timeout: ")

    sleep 15
    # $B%-%c%C%7%e$K%5%$%:@)8B$r$+$1$k(B
    cache_reduction($whois_cache, 2000, "as overflow: ")

  end
end

# end
